#ifndef TSX_TABLAHASH_H
#define TSX_TABLAHASH_H

#define MAXT 256

typedef struct extension {
	int valor;
	int modifica;
	struct extension *next;
} EXT;

struct thread_params {
	int tam_tabla_hash;
	int num_entradas;
	int max_iteraciones;
	int use_tsx;
};

struct thread_params global_params;

struct tsxStats {
	int ok;
	int nok;
	int capacity;
	int conflict;
	int explicit_tsx;
	int retriable;
	int debug;
	int nested;
};

void rellenar_tabla(int Entrada, int tam_tabla_hash, int num_entradas);
void init_tabla(int num_entradas, int tam_tabla_hash);
void Modifica(int Entrada, int num, int use_tsx);
void acquire_lock(pthread_mutex_t *mutex, int use_tsx);
void release_lock(pthread_mutex_t *mutex, int use_tsx);
void Busca(int Entrada, int num, int use_tsx);
struct tsxStats getTsxStats();
void reset_thread_counter();
void crea_hilo_busca();
void crea_hilo_modifica();
void join_all_threads();
void destroy_attr();

int verbose;

int caliente = 0;
int nentradas = 0;

int thread_count = 0;

int nTranOK = 0;
int nTranNOK = 0;
int retry = 0;
int conflict = 0;
int capacity = 0;
int debug = 0;
int nested = 0;
int explicitTran = 0;

EXT **Hash;
pthread_mutex_t mutex;
pthread_attr_t attr;
pthread_t tid[MAXT];
void *res;

int FIXED_WORKLOAD = 1;

#endif //TSX_TABLAHASH_H
