import itertools
import operator
from pychart import *
from pprint import pprint

import chart
import process


def group_by(data, n):
    data = sorted(data, key=operator.itemgetter(n))
    return dict((category, list(iterlist)) for category, iterlist in
                itertools.groupby(data, operator.itemgetter(n)))


def gen_times_chart():
    data = process.filter_data(chart_data.read_csv(SOURCE_FILE)[1:], lambda arr: arr[0] >= 80 and arr[0] < 106)

    columns = [
        (0, 'threads'),
        (2, 'entrEnlaz'),
        (3, 'tamTabla'),
        (lambda x: float(x[14]) / float(x[13]), 'speedup')
    ]

    data = process.process_data(data, columns)
    data_by_size = group_by(data, 2)

    for size in sorted(data_by_size.keys()):
        data_by_threads = group_by(data_by_size[size], 0)
        data_by_size[size] = []
        for numhilos in data_by_threads:
            linea = [numhilos]
            datos = sorted(data_by_threads[numhilos], key=operator.itemgetter(1))
            for dato in datos:
                linea.append(dato[3])
            data_by_size[size].append(linea)

    chart.generate(sorted(data_by_size[512], key=operator.itemgetter(0)), "-tam-512-big")


def gen_fails_chart():
    data = process.filter_data(chart_data.read_csv(SOURCE_FILE)[1:], lambda arr: arr[0] >= 80 and arr[0] < 106)

    columns = [
        (0, 'threads'),
        (2, 'entrEnlaz'),
        (3, 'tamTabla'),
        (6, 'NOK')
    ]

    data = process.process_data(data, columns)
    data_by_size = group_by(data, 2)

    for size in sorted(data_by_size.keys()):
        data_by_threads = group_by(data_by_size[size], 0)
        data_by_size[size] = []
        for numhilos in data_by_threads:
            linea = [numhilos]
            datos = sorted(data_by_threads[numhilos], key=operator.itemgetter(1))
            for dato in datos:
                linea.append(dato[3])
            data_by_size[size].append(linea)

    chart.generate_fails(sorted(data_by_size[512], key=operator.itemgetter(0)), "-fails-tam-512-big")


def gen_fails_reasons_chart_multidim():
    data = process.filter_data(chart_data.read_csv(SOURCE_FILE), lambda arr: arr[0] <= 5000)

    columns = [
        (0, 'threads'),
        (2, 'entrEnlaz'),
        (3, 'tamTabla'),
        (7, 'capac'),
        (8, 'conflict'),
        #(9, 'explicit'),
        #(10, 'retriable'),
        #(11, 'debug'),
        #(12, 'nested')
    ]

    data = process.process_data(data, columns)
    data_by_size = group_by(data[1:], 2)

    for size in sorted(data_by_size.keys()):
        data_by_threads = group_by(data_by_size[size], 0)
        data_by_size[size] = []
        for numhilos in data_by_threads:
            linea = [numhilos]
            datos = sorted(data_by_threads[numhilos], key=operator.itemgetter(1))
            for dato in datos:
                linea.append(dato[3])
                linea.append(dato[4])
            data_by_size[size].append(linea)

    chart.generate_fails_reasons_multidim(sorted(data_by_size[512], key=operator.itemgetter(0)), "-fails-reasons-tam-512")


def gen_fails_reasons_chart():
    data = process.filter_data(chart_data.read_csv(SOURCE_FILE), lambda arr: arr[0] <= 5000)

    columns = [
        (0, 'threads'),
        (2, 'entrEnlaz'),
        (3, 'tamTabla'),
        (7, 'capac'),
        (8, 'conflict'),
        #(9, 'explicit'),
        #(10, 'retriable'),
        #(11, 'debug'),
        #(12, 'nested')
    ]

    data = process.process_data(data, columns)
    data_by_size = group_by(data[1:], 2)

    chart.generate_fails_reasons(sorted(data_by_size[512], key=operator.itemgetter(0)), "fails-reasons-tam-512")


# SOURCE_FILE = '../Benchmark_results/variable_workload_iter_x_thread/computed-average.csv'
# SOURCE_FILE = '../Benchmark_results/64M_iter/tiempos-fixed-64m.csv'
# SOURCE_FILE = '../Benchmark_results/128M_iter/tiempos-fixed-128m.csv'
SOURCE_FILE = '../Benchmark_results/128M_iter/tiempos-fixed-128m-tam512.csv'
# SOURCE_FILE = '../Benchmark_results/128M_iter/tiempos-fixed-128miter-tam512-128mhilos.csv'

# gen_times_chart()
# gen_fails_chart()
gen_fails_reasons_chart_multidim()
# gen_fails_reasons_chart()
