# Gráficas generadas
Este apéndice reune todas las gráficas generadas durante el trabajo como complemento a las que son
destacadas durante el mismo. Las que ya han sido usadas en el trabajo no aparecerán aquí.

## Ejecución con carga de trabajo variable
En este caso, las gráficas representan un trabajo proporcional al número de hilos lanzados. Todas ellas representan
un valor de 100.000 iteraciones por cada hilo. En este caso las gráficas han 
sido generadas con la media aritmética de 5 ejecuciones iguales.

\begin{figure}[H]
    \begin{center}
        \includegraphics[width=0.8\textwidth]{img/variable/chart-tam-16}
    \end{center}
    \caption{Speedup para una tabla de tamaño 16 (carga variable, pocos hilos)}
\end{figure}

\begin{figure}[H]
    \begin{center}
        \includegraphics[width=0.8\textwidth]{img/variable/chart-tam-256}
    \end{center}
    \caption{Speedup para una tabla de tamaño 256 (carga variable, pocos hilos)}
\end{figure}

\begin{figure}[H]
    \begin{center}
        \includegraphics[width=0.8\textwidth]{img/variable/chart-tam-16-big}
    \end{center}
    \caption{Speedup para una tabla de tamaño 16 (carga variable, muchos hilos)}
\end{figure}

\begin{figure}[H]
    \begin{center}
        \includegraphics[width=0.8\textwidth]{img/variable/chart-tam-256-big}
    \end{center}
    \caption{Speedup para una tabla de tamaño 256 (carga variable, muchos hilos)}
\end{figure}

\begin{figure}[H]
    \begin{center}
        \includegraphics[width=0.8\textwidth]{img/variable/chart-fails-tam-16}
    \end{center}
    \caption{Total de fallos para una tabla de tamaño 16 entradas (carga variable, pocos hilos)}
\end{figure}

\begin{figure}[H]
    \begin{center}
        \includegraphics[width=0.8\textwidth]{img/variable/chart-fails-tam-32}
    \end{center}
    \caption{Total de fallos para una tabla de tamaño 32 entradas (carga variable, pocos hilos)}
\end{figure}

\begin{figure}[H]
    \begin{center}
        \includegraphics[width=0.8\textwidth]{img/variable/chart-fails-tam-64}
    \end{center}
    \caption{Total de fallos para una tabla de tamaño 64 entradas (carga variable, pocos hilos)}
\end{figure}

\begin{figure}[H]
    \begin{center}
        \includegraphics[width=0.8\textwidth]{img/variable/chart-fails-tam-128}
    \end{center}
    \caption{Total de fallos para una tabla de tamaño 128 entradas (carga variable, pocos hilos)}
\end{figure}

\begin{figure}[H]
    \begin{center}
        \includegraphics[width=0.8\textwidth]{img/variable/chart-fails-tam-256}
    \end{center}
    \caption{Total de fallos para una tabla de tamaño 256 entradas (carga variable, pocos hilos)}
\end{figure}

\begin{figure}[H]
    \begin{center}
        \includegraphics[width=0.8\textwidth]{img/variable/chart-fails-tam-512}
    \end{center}
    \caption{Total de fallos para una tabla de tamaño 512 entradas (carga variable, pocos hilos)}
\end{figure}

\begin{figure}[H]
    \begin{center}
        \includegraphics[width=0.8\textwidth]{img/variable/chart-fails-tam-16-big}
    \end{center}
    \caption{Total de fallos para una tabla de tamaño 16 entradas (carga variable, muchos hilos)}
\end{figure}

\begin{figure}[H]
    \begin{center}
        \includegraphics[width=0.8\textwidth]{img/variable/chart-fails-tam-32-big}
    \end{center}
    \caption{Total de fallos para una tabla de tamaño 32 entradas (carga variable, muchos hilos)}
\end{figure}

\begin{figure}[H]
    \begin{center}
        \includegraphics[width=0.8\textwidth]{img/variable/chart-fails-tam-64-big}
    \end{center}
    \caption{Total de fallos para una tabla de tamaño 64 entradas (carga variable, muchos hilos)}
\end{figure}

\begin{figure}[H]
    \begin{center}
        \includegraphics[width=0.8\textwidth]{img/variable/chart-fails-tam-128-big}
    \end{center}
    \caption{Total de fallos para una tabla de tamaño 128 entradas (carga variable, muchos hilos)}
\end{figure}

\begin{figure}[H]
    \begin{center}
        \includegraphics[width=0.8\textwidth]{img/variable/chart-fails-tam-256-big}
    \end{center}
    \caption{Total de fallos para una tabla de tamaño 256 entradas (carga variable, muchos hilos)}
\end{figure}

\begin{figure}[H]
    \begin{center}
        \includegraphics[width=0.8\textwidth]{img/variable/chart-fails-tam-512-big}
    \end{center}
    \caption{Total de fallos para una tabla de tamaño 512 entradas (carga variable, muchos hilos)}
\end{figure}

## Ejecución con carga de trabajo constante
Las siguientes gráficas muestran los datos obtenidos manteniendo constante el número de iteraciones, y dividiéndolo
entre el número de hilos.

### Con 64 millones de iteraciones

\begin{figure}[H]
    \begin{center}
        \includegraphics[width=0.8\textwidth]{img/64m/chart-tam-16}
    \end{center}
    \caption{Speedup para una tabla de tamaño 16 entradas (pocos hilos, carga constante de 64m iter.)}
\end{figure}

\begin{figure}[H]
    \begin{center}
        \includegraphics[width=0.8\textwidth]{img/64m/chart-tam-256}
    \end{center}
    \caption{Speedup para una tabla de tamaño 256 entradas (pocos hilos, carga constante de 64m iter.)}
\end{figure}

\begin{figure}[H]
    \begin{center}
        \includegraphics[width=0.8\textwidth]{img/64m/chart-tam-16-big}
    \end{center}
    \caption{Speedup para una tabla de tamaño 16 (muchos hilos, carga constante de 64m iter.)}
\end{figure}

\begin{figure}[H]
    \begin{center}
        \includegraphics[width=0.8\textwidth]{img/64m/chart-tam-256-big}
    \end{center}
    \caption{Speedup para una tabla de tamaño 256 (muchos hilos, carga constante de 64m iter.)}
\end{figure}


\begin{figure}[H]
    \begin{center}
        \includegraphics[width=0.8\textwidth]{img/64m/chart-fails-tam-16}
    \end{center}
    \caption{Fallos para una tabla de tamaño 16 entradas (pocos hilos, carga constante de 64m iter.)}
\end{figure}

\begin{figure}[H]
    \begin{center}
        \includegraphics[width=0.8\textwidth]{img/64m/chart-fails-tam-32}
    \end{center}
    \caption{Fallos para una tabla de tamaño 32 entradas (pocos hilos, carga constante de 64m iter.)}
\end{figure}

\begin{figure}[H]
    \begin{center}
        \includegraphics[width=0.8\textwidth]{img/64m/chart-fails-tam-64}
    \end{center}
    \caption{Fallos para una tabla de tamaño 64 entradas (pocos hilos, carga constante de 64m iter.)}
\end{figure}

\begin{figure}[H]
    \begin{center}
        \includegraphics[width=0.8\textwidth]{img/64m/chart-fails-tam-128}
    \end{center}
    \caption{Fallos para una tabla de tamaño 128 entradas (pocos hilos, carga constante de 64m iter.)}
\end{figure}

\begin{figure}[H]
    \begin{center}
        \includegraphics[width=0.8\textwidth]{img/64m/chart-fails-tam-256}
    \end{center}
    \caption{Fallos para una tabla de tamaño 256 entradas (pocos hilos, carga constante de 64m iter.)}
\end{figure}

\begin{figure}[H]
    \begin{center}
        \includegraphics[width=0.8\textwidth]{img/64m/chart-fails-tam-512}
    \end{center}
    \caption{Fallos para una tabla de tamaño 512 entradas (pocos hilos, carga constante de 64m iter.)}
\end{figure}


\begin{figure}[H]
    \begin{center}
        \includegraphics[width=0.8\textwidth]{img/64m/chart-fails-tam-16-big}
    \end{center}
    \caption{Total de fallos para una tabla de tamaño 16 entradas (muchos hilos, carga constante de 64m iter.)}
\end{figure}

\begin{figure}[H]
    \begin{center}
        \includegraphics[width=0.8\textwidth]{img/64m/chart-fails-tam-64-big}
    \end{center}
    \caption{Total de fallos para una tabla de tamaño 64 entradas (muchos hilos, carga constante de 64m iter.)}
\end{figure}

\begin{figure}[H]
    \begin{center}
        \includegraphics[width=0.8\textwidth]{img/64m/chart-fails-tam-128-big}
    \end{center}
    \caption{Total de fallos para una tabla de tamaño 128 entradas (muchos hilos, carga constante de 64m iter.)}
\end{figure}

\begin{figure}[H]
    \begin{center}
        \includegraphics[width=0.8\textwidth]{img/64m/chart-fails-tam-256-big}
    \end{center}
    \caption{Total de fallos para una tabla de tamaño 256 entradas (muchos hilos, carga constante de 64m iter.)}
\end{figure}

### Con 128 millones de iteraciones

\begin{figure}[H]
    \begin{center}
        \includegraphics[width=0.8\textwidth]{img/128m/chart-tam-16}
    \end{center}
    \caption{Speedup para una tabla de tamaño 16 entradas (pocos hilos, carga constante de 128m iter.)}
\end{figure}

\begin{figure}[H]
    \begin{center}
        \includegraphics[width=0.8\textwidth]{img/128m/chart-tam-32}
    \end{center}
    \caption{Speedup para una tabla de tamaño 32 entradas (pocos hilos, carga constante de 128m iter.)}
\end{figure}

\begin{figure}[H]
    \begin{center}
        \includegraphics[width=0.8\textwidth]{img/128m/chart-tam-64}
    \end{center}
    \caption{Speedup para una tabla de tamaño 64 entradas (pocos hilos, carga constante de 128m iter.)}
\end{figure}

\begin{figure}[H]
    \begin{center}
        \includegraphics[width=0.8\textwidth]{img/128m/chart-tam-128}
    \end{center}
    \caption{Speedup para una tabla de tamaño 128 entradas (pocos hilos, carga constante de 128m iter.)}
\end{figure}

\begin{figure}[H]
    \begin{center}
        \includegraphics[width=0.8\textwidth]{img/128m/chart-tam-256}
    \end{center}
    \caption{Speedup para una tabla de tamaño 256 entradas (pocos hilos, carga constante de 128m iter.)}
\end{figure}

\begin{figure}[H]
    \begin{center}
        \includegraphics[width=0.8\textwidth]{img/128m/chart-fails-tam-16}
    \end{center}
    \caption{Fallos para una tabla de tamaño 16 entradas (pocos hilos, carga constante de 128m iter.)}
\end{figure}

\begin{figure}[H]
    \begin{center}
        \includegraphics[width=0.8\textwidth]{img/128m/chart-fails-tam-32}
    \end{center}
    \caption{Fallos para una tabla de tamaño 32 entradas (pocos hilos, carga constante de 128m iter.)}
\end{figure}

\begin{figure}[H]
    \begin{center}
        \includegraphics[width=0.8\textwidth]{img/128m/chart-fails-tam-64}
    \end{center}
    \caption{Fallos para una tabla de tamaño 64 entradas (pocos hilos, carga constante de 128m iter.)}
\end{figure}

\begin{figure}[H]
    \begin{center}
        \includegraphics[width=0.8\textwidth]{img/128m/chart-fails-tam-128}
    \end{center}
    \caption{Fallos para una tabla de tamaño 128 entradas (pocos hilos, carga constante de 128m iter.)}
\end{figure}

\begin{figure}[H]
    \begin{center}
        \includegraphics[width=0.8\textwidth]{img/128m/chart-fails-tam-256}
    \end{center}
    \caption{Fallos para una tabla de tamaño 256 entradas (pocos hilos, carga constante de 128m iter.)}
\end{figure}
